/* this file automatically generated; see Makefile.in */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Floater Bridge Network.
 *
 * The Initial Developer of the Original Code is
 * Geoff Pike <pike@EECS.Berkeley.EDU>.
 * Portions created by the Initial Developer are Copyright (C) 1996-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the
 * terms of either the GNU General Public License Version 2 or later
 * (the "GPL"), in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of the MPL,
 * indicate your decision by deleting the provisions above and replace
 * them with the notice and other provisions required by the GPL. If
 * you do not delete the provisions above, a recipient may use your
 * version of this file under the terms of either the MPL or the GPL.
 * ***** END LICENSE BLOCK ***** */


char *helpdescriptions = "\n"
"	accept\n"
"Accept declarer's claim.  Must be used by each defender for a claim to\n"
"be accepted.\n"
"	alert\n"
"\"Alert some ... text ...\" is equivalent equivalent to \"explain Alert!\n"
"some ... text ...\" and is traditionally used to self-alert bids or\n"
"carding that is slightly unusual.  \"Redalert\" should be used for highly\n"
"unusual bids or carding.\n"
"	autodeal\n"
"After a certain amount of time elapses at the end of a hand, Floater\n"
"automatically deals a new hand if four people are seated.  To control\n"
"the timing, \"autodeal <N>\" sets the number of seconds to wait between\n"
"hands.  With no arguments, \"autodeal\" toggles on and off whether new\n"
"hands are ever dealt automatically.  (By the way, you must be host of\n"
"the table for your autodeal setting to have any effect.)\n"
"	beep\n"
"You may beep someone at your table by doing \"beep <name>\" (e.g., \"beep\n"
"Joe Smith\"), or you may beep everyone at your table by just doing\n"
"\"beep.\"  The bell will ring on the recipient's machine and everyone at\n"
"the table will see a message indicating who has beeped whom.\n"
"	beepAtMyTurn\n"
"There is an option that causes Floater to beep when it becomes your\n"
"turn to bid or play.  To toggle the described behavior, invoke this\n"
"command.  To turn it off, invoke this command with the argument \"no.\"\n"
"To turn it on, invoke this command with the argument \"yes.\"  See also\n"
"the options menu on the GUI.\n"
"	bid\n"
"Make a call.  For example, to bid 3 Notrump, do \"bid 3n\".  Each strain\n"
"is represented by a single letter: c for clubs, d for diamonds, h for\n"
"hearts, s for spades, and n for notrump.  \"Bid p,\" \"bid pass,\" \"bid\n"
"x,\" \"bid xx,\" \"bid double,\" and \"bid redouble\" have the obvious\n"
"meanings.  Unless you have customized the bindings (see \"bind\"), the\n"
"word \"bid\" may be omitted (\"3n\" is the same as \"bid 3n\" and so on).\n"
"	bind\n"
"Bind is used to create shorthand ways of specifying any command or\n"
"sequence of commands.  For example, \"bind typ say Thanks, pard!\" would\n"
"allow you to subsequently use \"typ\" as if it were a normal command.\n"
"Another example: Blue Club players might do \"bind 1c bid 1c; explain\n"
"Blue club: 17+ points, any distribution.\"\n"
"	bottom\n"
"If you are using the textual user interface, bottom is used to go to\n"
"the bottom of the scrolling talk window.  You may also use the scroll\n"
"command or the up and down array keys to select the portion of the\n"
"scrolling talk window you view.\n"
"	bug\n"
"Do \"bug <arbitrarily long one-line description>\" and an email message\n"
"containing your description and a dump of some internal variables will\n"
"be sent to the Floater maintainers.\n"
"	c\n"
"Play your lowest club.\n"
"	cards\n"
"Remind me what my cards were at the beginning of the hand.  May also\n"
"be used by kibitzers, with analogous meaning.\n"
"	cc\n"
"Invokes the textual user interface's convention card editor.  By\n"
"default you will be editing your side's convention card, or NS's if\n"
"you are not seated.  (\"Editing\" of a conventioning card other than\n"
"your own is really limited to viewing; changes are not allowed.)  The\n"
"three forms of the command are \"cc,\" \"cc NS,\" and \"cc EW.\"  If you are\n"
"using the GUI, \"cc\" is equivalent to \"ccdump\" because there is no\n"
"built-in editor for the GUI.\n"
"	ccdump\n"
"Show the specified convention card (e.g. \"ccdump NS\").  If none is specified,\n"
"show my convention card if I am seated or NS's otherwise.  Furthermore,\n"
"you may also specify a range of line numbers to display (e.g. \"1-5\" or\n"
"\"23-\" or \"-9\" or just \"17\").  Put the range first, if any, first;\n"
"so, \"ccdump -3\" or \"ccdump 12-16 NS.\"\n"
"	ccload\n"
"Load a convention card from the named text file (e.g. \"ccload sam.cc\")\n"
"and make it the convention card for my side.  You must be seated to\n"
"invoke the ccload command.\n"
"	ccsave\n"
"Save your current convention card to the named text file.\n"
"	children\n"
"Show who gets messages from me in the communication tree.  Primarily\n"
"intended for debugging.\n"
"	claim\n"
"As declarer, suggest to the defense that you are certain of some\n"
"number of tricks, and further play is not necessary.  The defenders\n"
"will be shown all four hands and may then use \"accept\" or \"reject\" and/or\n"
"continue playing.  Simply doing \"claim\" claims the rest of the tricks;\n"
"\"claim 3\" would mean a claim to make 3 of the remaining tricks;\n"
"\"claim -2\" would be a claim to make all but 2 of the\n"
"remaining tricks; \"claim 0\" means concede the rest; and \"claim +3\"\n"
"would be a claim for the contract plus 3 overtricks.\n"
"	close\n"
"Stop hosting (or close) your table.  You must be hosting a table for\n"
"this to be allowed.\n"
"	compact\n"
"The GUI has two general layouts: compact and non-compact.  Floater\n"
"will try to pick the best layout for your screen size, but you can\n"
"change it manually with this command.  Type \"compact yes\" or\n"
"\"compact no\" to try the two different layouts.\n"
"	competitive\n"
"Turns on competitive mode.  This is the default.  Results will be\n"
"reported by email for IMPs and MPs.  (Competitive mode is not relevant\n"
"to hearts or rubber bridge.)\n"
"	confusing\n"
"Display the `CONFUSING' file.\n"
"	copyright\n"
"Display copyright and warranty information.\n"
"	d\n"
"Play your lowest diamond.\n"
"	deal\n"
"Go on to the next hand.  May only be used by the host of the table.\n"
"	deiconifyIfBeeped\n"
"Normally when you are beeped by another player (see \"beep\"), your\n"
"Floater window is deiconified if it had been iconified.  This applies\n"
"only to the GUI.  To toggle the described behavior, invoke this\n"
"command.  To turn it off, invoke this command with the argument \"no.\"\n"
"To turn it on, invoke this command with the argument \"yes.\"  See also\n"
"the options menu on the GUI.\n"
"	disconnect\n"
"Close all network connections.  You will become a \"lurker.\"  If you\n"
"are hosting a table at the time you issue the command, it is\n"
"equivalent to \"close.\"\n"
"	down\n"
"A variant of the \"claim\" command.  For example, \"Down 2\" is a claim\n"
"for 2 fewer tricks than you have contracted for.\n"
"	e (or east)\n"
"If the East seat is available, take it.\n"
"	east (or e)\n"
"If the East seat is available, take it.\n"
"	emailchange\n"
"This command may be used to inform the Floater login server of a change in\n"
"your email address.  (Such changes do not apply to the Floater mailing list.)\n"
"You must be logged in to use the command, and you should specify your\n"
"full email address as an argument to the command (e.g., \"emailchange\n"
"bob@aol.com\").\n"
"	execute\n"
"Read a file and interpret the lines of the file as if they were typed\n"
"in on the command line at that moment.  E.g., \"execute ~/floater/foo.\"\n"
"	explain\n"
"Say something that everyone at the table except partner can hear.\n"
"This is typically used to explain conventional calls to the opponents\n"
"and kibitzers, among other things.\n"
"	find\n"
"Find information about people.  For example, \"find Joe Bob, elmo\" will\n"
"attempt to find information about the players Joe Bob and elmo.  Any\n"
"number of names, separated by commas, is allowed.  Recent information\n"
"about a player's location, if available, is among the things displayed.\n"
"	follow\n"
"Play the card of the named rank.  E.g. \"follow k.\"  Unless you have\n"
"customized the bindings (see \"bind\"), the word \"follow\" may be omitted\n"
"(\"7\" is the same as \"follow 7\" and so on).\n"
"	font\n"
"If you are using the GUI, you may change the font size for the matrix\n"
"and auction by doing \"font large,\" \"font medium,\" or \"font small.\" \n"
"(To change the font for the talk window, use the \"talkfont\" or\n"
"\"talkfontsize\" command.) \n"
"	h\n"
"Play your lowest heart.\n"
"	hideAuction\n"
"If you are using the GUI, you may use this command to control when\n"
"during the first trick the auction is removed from view.  The command\n"
"`hideAuction N' (for positive N) will cause the auction to be hidden\n"
"at the end of trick one or N seconds after the end of the auction,\n"
"whichever comes first.  The command `hideAuction -1' will cause the\n"
"auction to be hidden when trick one has completed.\n"
"	host\n"
"Host a new table.  Others may then connect to your table to play.\n"
"	ip\n"
"Display the IP address and port number that others may use to connect\n"
"to you.\n"
"	join\n"
"Join a table.  You must specify the name of the host of the table you\n"
"wish to join, e.g., \"join moe\".  (Alternatively, you may specify an IP\n"
"address and port separated by a colon, e.g., \"join 128.110.38.14:8765.\"\n"
"Or, to join a table hosted on your local machine, you may omit the IP\n"
"address and simply put the port number after a colon.)\n"
"	kibitz\n"
"Watch over one player's shoulder.  e.g. \"kib South\" or \"kib Joe Smith\"\n"
"	last\n"
"Show the previous trick.\n"
"	lho\n"
"Say something to your left-hand opponent.  E.g. \"lho Is that for penalty?\"\n"
"	login\n"
"Connect to the login server and transmit your account name and\n"
"password.  In return, the login server will check your password and\n"
"authenticate you to let you play under that account name.  In\n"
"addition, a list of tables currently in play will be sent to you,\n"
"allowing the \"tables\" command to give up-to-date information.\n"
"	make\n"
"A variant of the \"claim\" command.  With no arguments it is a claim to\n"
"make the contract exactly; with a positive integer argument it is a\n"
"claim to make a grand total of that number of tricks plus six.\n"
"	n (or north)\n"
"If the North seat is available, take it.\n"
"	newuser\n"
"Log in as a new user (see also \"login\").\n"
"	noncompetitive\n"
"Turns off competitive mode.  You will play the same hands as you would\n"
"otherwise, but results will not be reported by email.  (Not relevant\n"
"for hearts or rubber bridge.)\n"
"	north (or n)\n"
"If the North seat is available, take it.\n"
"	note\n"
"Set the text that is listed alongside my table's name when people use\n"
"the \"tables\" command.  For example, \"note Need 1!\"  You must be host\n"
"of the table.\n"
"	opp\n"
"Say something just to your opponents.  Frequently one would use\n"
"\"explain\" instead so that the kibitzers could also hear.\n"
"	parent\n"
"Show my parent in the communication tree.  Primarily intended for debugging.\n"
"	password\n"
"Change the password for an account.\n"
"	play\n"
"Play a card.  Cards are specified suit first, rank second.  For\n"
"example, \"play c3\" would play the 3 of clubs.  Unless you have\n"
"customized the bindings (see \"bind\"), the word \"play\" may be omitted\n"
"(\"c2\" is the same as \"play c2\" and so on).  In Hearts, this command is\n"
"also used to add or remove a card from the set of cards you wish to\n"
"pass to your opponent before the play of the hand.\n"
"	previous\n"
"Show the previous hand.\n"
"	punt\n"
"Forcibly make a player leave the table.  This command may only be used\n"
"by the host of the current table.\n"
"	quit\n"
"Terminate Floater.\n"
"	randomplay\n"
"Toggle a switch that, when set, causes automatic random plays or bids\n"
"whenever it is your turn.  Intended for debugging.\n"
"	readme\n"
"Display the `README' file.\n"
"	redalert\n"
"\"Redalert some ... text ...\" is equivalent equivalent to \"explain Red Alert!\n"
"some ... text ...\" and is traditionally used to self-alert bids or\n"
"carding that is highly unusual.  \"Alert\" should be used for only slightly\n"
"unusual bids or carding.\n"
"	reject\n"
"Reject declarer's claim.  A rejection from either defender nixes the\n"
"claim regardless of what the other defender may have done.  Others at\n"
"the table are shown only that the claim was rejected, not by whom.\n"
"	retract\n"
"Declarer may use this command to retract a claim.\n"
"	review\n"
"Review the auction.\n"
"	rho\n"
"Say something to your right-hand opponent.  E.g. \"rho What is 2D?\"\n"
"	s\n"
"If the south seat is available, try to sit down.  Otherwise, if you\n"
"are seated and it is your turn to play a card, play your lowest spade. \n"
"	say\n"
"Say something to everyone present.  E.g. \"say Hello There!\"\n"
"	score\n"
"Select the form of scoring for subsequent deals.  The valid uses of\n"
"the command are \"score IMP\" and \"score MP.\"  See also \"competitive\"\n"
"and \"noncompetitive.\"\n"
"	scroll\n"
"If you are using the textual user interface, scroll is used to change\n"
"which portion of the scrolling text window you view.  For example,\n"
"\"scroll -10\" takes you back 10 lines; \"scroll 20\" takes you forward 20\n"
"lines.  You may also use the bottom command or the up and down array\n"
"keys to select the portion of the scrolling talk window you view.\n"
"	showEntryLines\n"
"There are two different text-entry prompts in the graphical interface\n"
"to Floater: there is a \"talk\" entry line, and a \"command\" entry line.\n"
"Entries in the \"talk\" line are treated as messages to be spoken to the\n"
"others at the table, unless you prefix the entry with a slash (/) character.\n"
"Entries in the \"command\" line are treated as commands to Floater,\n"
"unless you prefix the entry with a double-quote (\") character.  To\n"
"change which entry lines you have available, type \"showEntryLines talk\",\n"
"\"showEntryLines command\", or \"showEntryLines both\".\n"
"	separateTalk\n"
"This command applies only to the GUI.  By default, the messages (e.g.,\n"
"from people talking) that Floater displays appear in a scrollable box\n"
"towards the bottom of the main Floater window.  If invoked with no\n"
"arguments, this command toggles whether that is true or whether\n"
"Floater has a separate window just for those messages.  It also may be\n"
"invoked with an argument of \"yes\" or \"no,\" with the obvious meaning.\n"
"See also the options menu in the GUI.\n"
"	south (or s)\n"
"If the South seat is available, take it.\n"
"	spec\n"
"Become a double-dummy spectator.\n"
"	stand\n"
"If you are sitting North, South, East, or West, this is the way to get up.\n"
"	tables\n"
"List all tables.\n"
"	talkfont\n"
"If you are using the GUI, you may change the font family for the talk\n"
"window by doing, for example, \"talkfont times.\"  On some systems, not\n"
"all fonts are available in all sizes.\n"
"	talkfontsize\n"
"If you are using the GUI, you may change the font size for the talk\n"
"window by doing \"talkfontsize N\" for any number N.  The number N is\n"
"interpreted as a size in points.  One point is roughly 1/72 inch.\n"
"	unseat\n"
"Forcibly make a player stand up from the seat they are in.  This\n"
"command may only be used by the host of the current table.\n"
"	w (or west)\n"
"If the West seat is available, take it.\n"
"	warranty\n"
"Display copyright and warranty information.\n"
"	west (or w)\n"
"If the West seat is available, take it.\n"
"	who\n"
"List who is at the table I am at.\n"
"	whois\n"
"An IRC user suggested that \"whois\" should be interchangeable with\n"
"\"find\" in Floater.  See find.\n"
"	.\n"
"Play your smallest card of the suit led.\n"
;

char *helpcommands = 
"accept alert autodeal beep beepAtMyTurn bid bind bottom bug c cards cc ccdump ccload ccsave children claim close compact competitive confusing copyright d deal deiconifyIfBeeped disconnect down e (or east) east (or e) emailchange execute explain find follow font h hideAuction host ip join kibitz last lho login make n (or north) newuser noncompetitive north (or n) note opp parent password play previous punt quit randomplay readme redalert reject retract review rho s say score scroll showEntryLines separateTalk south (or s) spec stand tables talkfont talkfontsize unseat w (or west) warranty west (or w) who whois . ";
